hud.add(function(v, p)
	if p.mo and p.mo.skin == "jetmetalsonic"
	and p.powers[pw_carry] ~= CR_NIGHTSMODE

		//Draw the Charge Meter on the HUD, based on Inuyasha's Boss HUD code
		if p.menu.contents[1][1].value --Check to see if the Charge Meter is enabled

			local posx = 17
			local posy = 57

			local CHARGECAP = 99
			local CHARGEFILL = (p.chrgbuildUp*100/FULL_CHARGE_BUILDUP)*CHARGECAP/100

			--Set charge meter fill colour based on menu setting
			local fillcolor = p.mo.color
			if p.prevcolor
				fillcolor = p.prevcolor
			end
			if p.menu.contents[1][2].value == 1
				fillcolor = SKINCOLOR_BLUE
			elseif p.menu.contents[1][2].value == 2
				fillcolor = SKINCOLOR_ORANGE
			elseif p.menu.contents[1][2].value == 3
				fillcolor = SKINCOLOR_RED
			elseif p.menu.contents[1][2].value == 4
				fillcolor = SKINCOLOR_ROSY
			elseif p.menu.contents[1][2].value == 5
				fillcolor = SKINCOLOR_PURPLE
			elseif p.menu.contents[1][2].value == 6
				fillcolor = SKINCOLOR_YELLOW
			elseif p.menu.contents[1][2].value == 7
				fillcolor = SKINCOLOR_GREEN
			end

			--Draw the charge meter
			v.draw(posx, posy, v.cachePatch("CMTRBCKG"), V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER)
			posy = $+(CHARGECAP-1)
			for i = 1, CHARGECAP
				if CHARGEFILL >= i
					v.draw(posx, posy, v.cachePatch("CMTRFILL"), V_30TRANS|V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER, v.getColormap(SKIN, fillcolor))
				end
				posy = $-1
			end
			posy = $+1
			v.draw(posx, posy, v.cachePatch("CMTRBASE"), V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER)
			posx = $+3
			posy = $+CHARGECAP+2
			if p.charges > 3
				v.drawString(posx, posy, "4", V_PERPLAYER, "left")
			elseif p.charges > 2
				v.drawString(posx, posy, "3", V_PERPLAYER, "left")
			elseif p.charges > 1
				v.drawString(posx, posy, "2", V_PERPLAYER, "left")
			elseif p.charges > 0
				v.drawString(posx, posy, "1", V_PERPLAYER, "left")
			else
				v.drawString(posx, posy, "0", V_PERPLAYER, "left")
			end
		end

		//Draw the Combo Counter on the HUD
		if p.menu.contents[1][4].value --Check to see if the Combo Counter is enabled
			if p.combocount > 1
				local posx = 60
				local posy = 148

				--Shift the Combo Counter to the left if the Charge Meter is disabled
				if not p.menu.contents[1][1].value
					posx = $-18
				end

				--Counter cannot display beyond 2 digits
				if p.combocount > 99
					v.drawPaddedNum(posx, posy, 99, 2, V_PERPLAYER|V_SNAPTOLEFT)
				else
					v.drawPaddedNum(posx, posy, p.combocount, 2, V_PERPLAYER|V_SNAPTOLEFT)
				end

				posx = $-25
				posy = $+12
				v.drawString(posx, posy, "hits!", V_PERPLAYER|V_SNAPTOLEFT|V_YELLOWMAP, "left")
			end
		end
	end
end, "game")