//Allocate freeslots
freeslot(
	"SPR_JMSC","SPR_JMSA",
	"SPR2_CHRG","SPR2_CJMP","SPR2_JMSB",
	"S_PLAY_CHRGJMP","S_PLAY_CHRGTHK","S_PLAY_POSTWBNC","S_PLAY_POSTHOME",
	"S_LAUNCHEFF","S_CHRGSPARKLE","S_JETMETBSTERA","S_JETMETBSTERB",
	"MT_JETMETBSTERA","MT_JETMETBSTERB",
	"SKINCOLOR_JETMETAL"
	)
for i = 1, 7 freeslot("S_CHRGEFF"..i) end
for i = 1, 5 freeslot("SKINCOLOR_SUPERJETMETAL"..i) end

//Define states
states[S_PLAY_CHRGJMP] = {SPR_PLAY, SPR2_CJMP|FF_ANIMATE, -1, nil, 7, 1, S_PLAY_ROLL}
states[S_PLAY_CHRGTHK] = {SPR_PLAY, SPR2_DASH|A, 14, nil, 0, 0, S_PLAY_ROLL}
states[S_PLAY_POSTWBNC] = {SPR_PLAY, SPR2_SPNG|A, 14, nil, 0, 0, S_PLAY_ROLL}
states[S_PLAY_POSTHOME] = {SPR_PLAY, SPR2_SPNG|A, 14, nil, 0, 0, S_PLAY_ROLL}

states[S_LAUNCHEFF] = {SPR_JMSC, FF_TRANS50|FF_FULLBRIGHT|FF_ANIMATE, 7, nil, 6, 1, S_NULL}
states[S_CHRGSPARKLE] = {SPR_NSPK, FF_TRANS20|FF_FULLBRIGHT|FF_ANIMATE, 8, nil, 3, 1, S_NULL}
states[S_CHRGEFF1] = {SPR_JMSC, FF_TRANS50|FF_PAPERSPRITE|FF_FULLBRIGHT|G, 1, nil, 0, 0, S_CHRGEFF2}
states[S_CHRGEFF2] = {SPR_JMSC, FF_TRANS50|FF_PAPERSPRITE|FF_FULLBRIGHT|F, 1, nil, 0, 0, S_CHRGEFF3}
states[S_CHRGEFF3] = {SPR_JMSC, FF_TRANS50|FF_PAPERSPRITE|FF_FULLBRIGHT|E, 1, nil, 0, 0, S_CHRGEFF4}
states[S_CHRGEFF4] = {SPR_JMSC, FF_TRANS50|FF_PAPERSPRITE|FF_FULLBRIGHT|D, 1, nil, 0, 0, S_CHRGEFF5}
states[S_CHRGEFF5] = {SPR_JMSC, FF_TRANS50|FF_PAPERSPRITE|FF_FULLBRIGHT|C, 1, nil, 0, 0, S_CHRGEFF6}
states[S_CHRGEFF6] = {SPR_JMSC, FF_TRANS50|FF_PAPERSPRITE|FF_FULLBRIGHT|B, 1, nil, 0, 0, S_CHRGEFF7}
states[S_CHRGEFF7] = {SPR_JMSC, FF_TRANS50|FF_PAPERSPRITE|FF_FULLBRIGHT|A, 1, nil, 0, 0, S_NULL}
states[S_JETMETBSTERA] = {SPR_NULL, A, -1, nil, 0, 0, S_NULL}
states[S_JETMETBSTERB] = {SPR_NULL, B, -1, nil, 0, 0, S_NULL}

//Define objects
mobjinfo[MT_JETMETBSTERA] = {spawnstate = S_JETMETBSTERA, radius = 20*FRACUNIT, height = 16*FRACUNIT, flags = MF_NOCLIP|MF_NOGRAVITY|MF_NOCLIPHEIGHT|MF_NOCLIPTHING}
mobjinfo[MT_JETMETBSTERB] = {spawnstate = S_JETMETBSTERB, radius = 20*FRACUNIT, height = 16*FRACUNIT, flags = MF_NOCLIP|MF_NOGRAVITY|MF_NOCLIPHEIGHT|MF_NOCLIPTHING}

//Define skincolours
skincolors[SKINCOLOR_JETMETAL] = {name = "JetMetal", ramp = {3,15,19,23,25,27,29,29,29,30,30,30,30,30,31,31}, accessible = true}

skincolors[SKINCOLOR_SUPERJETMETAL1] = {name = "Super JetMetal 1", ramp = {3,15,19,23,25,27,29,29,29,30,30,30,30,30,31,31}, accessible = false}
skincolors[SKINCOLOR_SUPERJETMETAL2] = {name = "Super JetMetal 2", ramp = {3,15,19,23,236,79,238,238,238,239,239,239,239,239,239,239}, accessible = false}
skincolors[SKINCOLOR_SUPERJETMETAL3] = {name = "Super JetMetal 3", ramp = {89,65,190,190,77,191,78,78,78,79,79,79,79,238,238,239}, accessible = false}
skincolors[SKINCOLOR_SUPERJETMETAL4] = {name = "Super JetMetal 4", ramp = {89,85,66,190,190,77,77,191,78,78,78,79,79,79,238,239}, accessible = false}
skincolors[SKINCOLOR_SUPERJETMETAL5] = {name = "Super JetMetal 5", ramp = {89,85,65,66,190,190,190,77,191,191,78,78,79,79,238,239}, accessible = false}

//Define global functions
rawset(_G, "SpawnLaunchEffect", function(p, abil, size, color)
	local lncheff = P_SpawnMobj(p.mo.x, p.mo.y, (p.mo.z + 36 * p.mo.scale), MT_THOK)
	lncheff.state = S_LAUNCHEFF
	lncheff.color = color
	lncheff.scale = FixedMul(size, p.mo.scale)
	if abil == 1
		lncheff.frame = $|FF_PAPERSPRITE
		lncheff.angle = p.mo.angle + ANGLE_90
	else
		lncheff.frame = $|FF_FLOORSPRITE
	end
end)